package ovrstat

type OwApiResponse struct {
	Icon string `json:"icon"`
	Name string `json:"name"`
	Level int `json:"level"`
	LevelIcon string `json:"levelIcon"`
	Prestige int `json:"prestige"`
	PrestigeIcon string `json:"prestigeIcon"`
	Rating string `json:"rating"`
	RatingName string `json:"ratingName"`
	RatingIcon string `json:"ratingIcon"`
	GamesWon int `json:"gamesWon"`
	QuickPlayStats *GameplayStats `json:"quickPlayStats"`
	CompetitiveStats *GameplayStats `json:"competitiveStats"`
}

type GameplayStats struct {
	EliminationsAvg float64 `json:"eliminationsAvg"`
	DamageDoneAvg int `json:"damageDoneAvg"`
	DeathsAvg float64 `json:"deathsAvg"`
	FinalBlowsAvg float64 `json:"finalBlowsAvg"`
	HealingDoneAvg int `json:"healingDoneAvg"`
	ObjectiveKillsAvg float64 `json:"objectiveKillsAvg"`
	ObjectiveTimeAvg string `json:"objectiveTimeAvg"`
	SoloKillsAvg float64 `json:"soloKillsAvg"`
	Games *GamesStats `json:"games"`
	Awards *AwardsStats `json:"awards"`
	CareerStats *CareerStats `json:"careerStats"`
}

type GamesStats struct {
	Played int `json:"played"`
	Won int `json:"won"`
}

type AwardsStats struct {
	Cards int `json:"cards"`
	Medals int `json:"medals"`
	BronzeMedals int `json:"medalsBronze"`
	SilverMedals int `json:"medalsSilver"`
	GoldMedals int `json:"medalsGold"`
}

type HeroStat struct {
	TimePlayed string `json:"timePlayed"`
	GamesWon int `json:"gamesWon"`
	WinPercentage int `json:"winPercentage"`
	WeaponAccuracy int `json:"weaponAccuracy"`
	EliminationsPerLife float64 `json:"eliminationsPerLife"`
	MultiKillBest int `json:"multiKillBest"`
	ObjectiveKillsAvg float64 `json:"objectiveKillsAvg"`
}

type CareerStats struct {
	AllHeroes *CareerStat `json:"allHeroes"`
}

type CareerStat struct {
	Assists *AssistStats `json:"assists"`
	Combat *CombatStats `json:"combat"`
	Deaths *DeathStats `json:"deaths"`
}

type AssistStats struct {
	HealingDone int64 `json:"healingDone"`
	OffensiveAssists int64 `json:"offensiveAssists"`
	SelfHealing int64 `json:"offensiveAssists"`
	TurretsDestroyed int64 `json:"turretsDestroyed"`
}

type CombatStats struct {
	DamageDone int64 `json:"damageDone"`
	Eliminations int `json:"eliminations"`
	EnvironmentalKills int `json:"environmentalKills"`
	FinalBlows int `json:"finalBlows"`
	MeleeFinalBlows int `json:"meleeFinalBlows"`
	MultiKills int `json:"multikills"`
	ObjectiveKills int `json:"objectiveKills"`
	SoloKills int `json:"soloKills"`
}

type DeathStats struct {
	Deaths int `json:"deaths"`
	EnvironmentalDeaths int `json:"environmentalDeaths"`
}